summaryrefslogtreecommitdiff
path: root/contrib/run-script-smtcomp2016-application
diff options
context:
space:
mode:
authorajreynol <andrew.j.reynolds@gmail.com>2016-05-10 14:33:08 -0500
committerajreynol <andrew.j.reynolds@gmail.com>2016-05-10 14:33:15 -0500
commit33e781995fb1384473fdec386c981a4aeb50b356 (patch)
tree286c18e5e330b110ae3b8126e265811fe0d0688e /contrib/run-script-smtcomp2016-application
parentc15ff43597b41ea457befecb1b0e2402e28cb523 (diff)
Add smt comp 2016 scripts. Fix for --relevant-triggers. Add minor optimizations to sygus and qcf.
Diffstat (limited to 'contrib/run-script-smtcomp2016-application')
-rw-r--r--contrib/run-script-smtcomp2016-application55
1 files changed, 55 insertions, 0 deletions
diff --git a/contrib/run-script-smtcomp2016-application b/contrib/run-script-smtcomp2016-application
new file mode 100644
index 000000000..750d25187
--- /dev/null
+++ b/contrib/run-script-smtcomp2016-application
@@ -0,0 +1,55 @@
+#!/bin/bash
+
+cvc4=./cvc4-application
+
+read line
+if [ "$line" != '(set-option :print-success true)' ]; then
+ echo 'ERROR: first line supposed to be set-option :print-success, but got: "'"$line"'"' >&2
+ exit 1
+fi
+echo success
+read line
+logic=$(expr "$line" : ' *(set-logic *\([A-Z_]*\) *) *$')
+if [ -z "$logic" ]; then
+ echo 'ERROR: second line supposed to be set-logic, but got: "'"$line"'"' >&2
+ exit 1
+fi
+echo success
+
+function runcvc4 {
+ # we run in this way for line-buffered input, otherwise memory's a
+ # concern (plus it mimics what we'll end up getting from an
+ # application-track trace runner?)
+ $cvc4 --force-logic="$logic" -L smt2 --print-success --no-checking --no-interactive "$@" <&0-
+}
+
+case "$logic" in
+
+QF_LRA)
+ runcvc4 --tear-down-incremental --unconstrained-simp
+ ;;
+QF_LIA)
+ # same as QF_LRA but add --pb-rewrites
+ runcvc4 --tear-down-incremental --unconstrained-simp
+ ;;
+ALIA|AUFLIA|AUFLIRA|AUFNIRA|UF|UFBV|UFIDL|UFLIA|UFLRA|UFNIA)
+ runcvc4 --tear-down-incremental
+ ;;
+BV)
+ runcvc4 --cbqi-all --tear-down-incremental
+ ;;
+LIA|LRA|NIA|NRA)
+ runcvc4 --tear-down-incremental
+ ;;
+QF_BV)
+ runcvc4 --tear-down-incremental --unconstrained-simp --bv-eq-slicer=auto --bv-div-zero-const --bv-intro-pow2
+ ;;
+QF_AUFLIA|QF_AX)
+ runcvc4 --tear-down-incremental --no-arrays-eager-index --arrays-eager-lemmas
+ ;;
+*)
+ # just run the default
+ runcvc4 --tear-down-incremental
+ ;;
+
+esac
generated by cgit on debian on lair
contact matthew@masot.net with questions or feedback